
module Common.Util where

-- Products ---------------------------------------------------------------

infix 7 /\
(/\) :: (a -> b) -> (a -> c) -> a -> (b,c)
(f /\ g) x = (f x, g x)

infix 5 -*-
(-*-) :: (a -> c) -> (b -> d) -> (a,b) -> (c,d)
f -*- g = f . fst /\ g . snd

pi1_3 (x,_,_) = x
pi2_3 (_,x,_) = x
pi3_3 (_,_,x) = x

pi12_3 (x,y,_)	= (x,y)
pi13_3 (x,_,y)	= (x,y)
pi23_3 (_,x,y)	= (x,y)

-- Sums -------------------------------------------------------------------

infix 6 \/
(\/) = either

infix 4 -+-
f -+- g = Left . f \/ Right . g

-- An error monad ---------------------------------------------------------

type ErrM = Either String

runErr = error \/ id

