{-# OPTIONS -fth #-}

module GenericHaskell.Map where

import Language.Haskell.THSyntax

import GenericHaskell.GH
import Common.Util

_Map :: KindIndexedType
_Map = kindIndexedType 2 0 $
	\[t1, t2] -> t1 --> t2

gmapType :: GenericType
gmapType k t = _Map k [t,t]

gmap :: GenericFun
gmap = gmap' []
    where
	gmap' env t = case t of
	    Sum	    -> [| (-+-) |]
	    Prod    -> [| (-*-) |]
	    Unit    -> [| id |]
	    t	    -> defaultTrans "gmap" gmap' env t

gmapG :: Generic
gmapG = ("gmap", gmapType, gmap)

